## net.sf.saxon.value
Class SingletonClosure

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.Closure
              net.sf.saxon.value.SingletonClosure

All Implemented Interfaces:
  java.io.Serializable, SequenceIterable, ValueRepresentation

    public class SingletonClosure

extends Closure

A SingletonClosure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on. The value of a SingletonClosure is always either a single item or an empty sequence.

The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.Closure
`depth, expression, inputIterator, savedXPathContext`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`SingletonClosure(Expression exp, XPathContext context)` Constructor should not be called directly, instances should be made using the make() method.

Method Summary
`Item` `asItem()` Return the value in the form of an Item
`int` `getLength()` Get the length of the sequence
`Item` `itemAt(int n)` Get the n'th item in the sequence (starting from 0).
`SequenceIterator` `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
`Value` `materialize()` Return a value containing all the items in the sequence returned by this SequenceIterator
`void` `process(XPathContext context)` Process the expression by writing the value to the current Receiver

Methods inherited from class net.sf.saxon.value.Closure
`getCardinality, getItemType, make, makeIteratorClosure, reduce, saveContext`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, checkPermittedContents, convertToJava, effectiveBooleanValue, equals, fromItem, getCanonicalLexicalRepresentation, getIterator, getSchemaComparable, getStringValue, getStringValueCS, iterate, makeQNameValue, stringToNumber, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SingletonClosure

    public SingletonClosure(Expression exp,
                            XPathContext context)
                     throws XPathException

  Constructor should not be called directly, instances should be made using the make() method.

  Parameters:
    `exp` - the expression to be lazily evaluated
    `context` - the context in which the expression should be evaluated
  Throws:
    `XPathException`

Method Detail

### iterate

    public SequenceIterator iterate()
                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Overrides:
    `iterate` in class `Closure`
  Returns:
    an iterator over the sequence of items
  Throws:
    `XPathException` - if a dynamic error occurs. This is possible only in the case of values that are materialized lazily, that is, where the iterate() method leads to computation of an expression that delivers the values.

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the expression by writing the value to the current Receiver

  Overrides:
    `process` in class `Closure`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### asItem

    public Item asItem()
                throws XPathException

  Return the value in the form of an Item

  Overrides:
    `asItem` in class `Value`
  Returns:
    the value in the form of an Item
  Throws:
    `XPathException`

### itemAt

    public Item itemAt(int n)
                throws XPathException

  Get the n'th item in the sequence (starting from 0). This is defined for all SequenceValues, but its real benefits come for a SequenceValue stored extensionally

  Overrides:
    `itemAt` in class `Value`
  Parameters:
    `n` - position of the required item, counting from zero.
  Returns:
    the n'th item in the sequence, where the first item in the sequence is numbered zero. If n is negative or >= the length of the sequence, returns null.
  Throws:
    `XPathException`

### getLength

    public int getLength()
                  throws XPathException

  Get the length of the sequence

  Overrides:
    `getLength` in class `Value`
  Returns:
    the number of items in the sequence
  Throws:
    `XPathException`

### materialize

    public Value materialize()
                      throws XPathException

  Return a value containing all the items in the sequence returned by this SequenceIterator

  Returns:
    the corresponding value
  Throws:
    `XPathException`

Copyright (c) Saxonica Limited. All rights reserved.